import java.io.File;

/**
 * A node object associated with each node in a JTree. 
 * <p>
 * DotNodeInfo stores a dot File in it <br />
 * </p>
 * @author NGUYEN, T.V
 *
 */
public class DotNodeInfo {
	/**
	 * Create a new instance of DotNodeInfo
	 * @param pathToDot: absolute path to the dot file
	 */
	public DotNodeInfo(String pathToDot) {
		// if there is a dot file represents this source
		if (!pathToDot.equals("")) {
			dotFile = new File(pathToDot);
			if (!dotFile.exists()) {
				MainFrame.printMessage("DotNodeInfo:10: " + pathToDot + " not found");
			}
		}	
	}
	
	public String toString() {
		return dotFile.getName();
	}
	
	File dotFile = null;
}
