import java.io.File;
/**
 * A node object associated with each node in a JTree. 
 * <p>
 * FuncNodeInfo stores a dot File in it and name of the function<br />
 * </p>
 * @author NGUYEN, T.V
 *
 */

public class FuncNodeInfo {
	/**
	 * Create a new instance of FuncNodeInfo. 
	 * @param name: name of function
	 * @param pathToDot: absolute path to the dot File represents the function
	 */
	public FuncNodeInfo(String name, String pathToDot) {
		this.name = name;
		dotFile = new File(pathToDot);
		if (!dotFile.exists()) {
			MainFrame.printMessage("FuncNodeInfo:13 " + pathToDot + " not found");
		}	
	}
	
	public String toString() {
		return name;
	}

	String name;
	File dotFile;
}
