import java.io.File;
import java.util.StringTokenizer;

/**
 * Models a location (i.e, source file and start, end line number)
 * that is attached to an element in graph
 * 
 * Date: July 28, 2008
 * @author Trung, N.V 
 * 
 */
public class Location {
	public Location(String loc) {
		StringTokenizer tokenizer = new StringTokenizer(loc, ":");
		if (tokenizer.countTokens() == 3) {
			source = tokenizer.nextToken();
			File f = new File(source);
			if (!f.exists()) {
				MainFrame.printMessage("Error: file " + source + " not found!");
				return;
			} else {
				startLine = Integer.parseInt(tokenizer.nextToken());
				endLine = Integer.parseInt(tokenizer.nextToken());
			}	
		} else {
			MainFrame.printMessage("Error: location should has this "
				+ " format: fullPath:startLine:endLine");
		}
	}
	
	public String toString() {
		String res = "";
		res += "Source: " + source + "\n";
		res += "From line " + startLine + "to line " + endLine + "\n";
		return res;
	}
	
	// data
	String source;
	int startLine = -1;
	int endLine  = -1;
}
