import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.PrintWriter;

import javax.swing.JOptionPane;
import javax.swing.JScrollBar;
import javax.swing.border.TitledBorder;
import javax.swing.text.Caret;
import javax.swing.text.Utilities;

import att.grappa.Element;
import att.grappa.Graph;
import att.grappa.GrappaAdapter;
import att.grappa.GrappaPanel;
import att.grappa.GrappaPoint;
import att.grappa.Subgraph;

/**
 * A listener class that extends GrappaAdapter 
 * to enable jumping to source location.
 * @author Trung, N.V
 * Date: 31 Jul, 2008
 *
 */
class MyGrappaAdapter extends GrappaAdapter {
   	public void grappaClicked(Subgraph subg,
            Element elem,
            GrappaPoint pt,
            int modifiers,
            int clickCount,
            GrappaPanel panel) {
    	// rectangle around
    	super.grappaClicked(subg, elem, pt, modifiers, clickCount, panel);
    	try {
    		String location = (String) elem.getAttributeValue("comment");
    		if (location != null) { // if a source is attached to this element
    			Location loc = new Location(location); 
    			if (loc.startLine == -1 || loc.endLine == -1)
    				return;
    			
    			File source = new File(loc.source);
    			MainFrame.displaySource(source);
    			Caret c = MainFrame.sourceView.getCaret();
    			int pos = 0;
    			javax.swing.text.Element element;
    			try {
    				for (int i = 0; i < loc.startLine - 1; i++) {
    					element = Utilities.getParagraphElement(MainFrame.sourceView, pos);
    					pos = element.getEndOffset();
    				}
    				// set start position
    				c.setDot(pos);
    				c.setSelectionVisible(true);
    				
    				//c.getMark();
    				// take the start position as start of visible rect
        			Rectangle rpos = MainFrame.sourceView.modelToView(pos);
        			Rectangle visibleR = MainFrame.sourceView.getVisibleRect();
        			Rectangle newR = new Rectangle(
        									visibleR.x, 
        									rpos.y - visibleR.height/3,
        									visibleR.width, 
        									visibleR.height);
        			pos = 0;
    				for (int i = 0; i < loc.endLine; i++) {
    					element = Utilities.getParagraphElement(MainFrame.sourceView, pos);
    					pos = element.getEndOffset();
    				}
    				// move here to mark the entire paragraph
    				c.moveDot(pos);
    				MainFrame.sourceView.scrollRectToVisible(newR);
    			} catch (Exception ex) {
    				System.err.println(ex.getMessage());
    				return;
    			}
    		  }
    	} catch (Exception e) {
   			System.err.println(e.getMessage());
    	}
   	}
}
