import java.io.File;

/**
 * A node object associated with each node in a JTree. 
 * <p>
 * SourceNodeInfo stores a dot File and a source file<br />
 * </p>
 * @author NGUYEN, T.V
 *
 */
public class SourceNodeInfo {
	/**
	 * Create a new instance of source node info. 
	 * @param pathToSource: absolute path to source file
	 * @param pathToDot: absolute path to dot file
	 */
	public SourceNodeInfo(String pathToSource, String pathToDot) {
		sourceFile = new File(pathToSource);
		if (!sourceFile.exists()) {
			System.err.println("SourceNodeInfo:13:Error! " + pathToSource + " not found");
			//System.exit(1);
		}
		// if there is a dot file represents this source
		if (!pathToDot.equals("")) {
			dotFile = new File(pathToDot);
			if (!dotFile.exists()) {
				System.err.println("SourceNodeInfo:20:Error! " + pathToDot + " not found");
				//System.exit(1);
			}
		}	
	}
	
	public String toString() {
		return sourceFile.getName();
	}
	
	File sourceFile = null;
	File dotFile = null;
}
