import java.awt.BorderLayout;

import javax.swing.*;
/**
 * A tabbed panel that contains two tabs, one for project source
 * code explorer and one for generated dot file explorer
 * 
 * @author TRUNG, N.V
 *
 */
public class TabbedPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public TabbedPanel(JComponent sourcePanel, JComponent graphPanel) {
		super(new BorderLayout());
		
		pane = new JTabbedPane();
		java.net.URL url;
		url = MainFrame.class.getResource("images/project.png");
		pane.addTab("Project", new ImageIcon(url), sourcePanel, "Project explorer");
		url = MainFrame.class.getResource("images/graph.png");
		pane.addTab("Graph", new ImageIcon(url), graphPanel, "Graph explorer");
		pane.setTabPlacement(JTabbedPane.BOTTOM);
		pane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
		//pane.setTabLayoutPolicy(JTabbedPane.WRAP_TAB_LAYOUT);
		add(pane, BorderLayout.CENTER);
	}
	
	// protected data
	JTabbedPane pane;
}
