#include <assert.h>
#include <anlab_malloc.h>

//void *malloc(size_t);

#define NUM_PDE		(1024)

typedef unsigned int	u32;
typedef u32		page_entry_t;

page_entry_t *page_entries_1;
page_entry_t *page_entries_2;
page_entry_t *page_entries_3;

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_1(u32 pde_index)
{
	return page_entries_1[pde_index];
}

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_2(u32 pde_index)
{
	return page_entries_2[pde_index];
}

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_pde_3(u32 pde_index)
{
	return page_entries_2[pde_index];
}

/*
 *	page_entries_{1,2,3} are allocated here.
 */
int page_entries_init(void)
{
	page_entries_1 = malloc(sizeof(page_entry_t) * NUM_PDE);
	page_entries_2 = malloc(sizeof(page_entry_t) * NUM_PDE);
	page_entries_3 = malloc(sizeof(page_entry_t) * NUM_PDE);

	if (page_entries_1 && page_entries_2 && page_entries_3)
		return 0;

	return -1;
}

void main(void)
{
	if (page_entries_init())
		return;

	page_entry_t pde1 = get_pde_1(0);
	page_entry_t pde2 = get_pde_2(1);
	page_entry_t pde3 = get_pde_3(NUM_PDE - 1);
}
