#include <assert.h>

#define NUM_PDE		(1024)

typedef unsigned int	u32;
typedef u32		page_entry_t;

struct page_directory {
	page_entry_t entries[NUM_PDE];
};

struct page_directory guest_page_directory;
struct page_directory vmm_page_directory;

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t get_guest_pde(u32 pde_index)
{
	return guest_page_directory.entries[pde_index];
}

/*@
	$requires ((pde_index >= 0) && (pde_index < NUM_PDE));
 */
page_entry_t* get_vmm_pde(u32 pde_index)
{
	return &vmm_page_directory.entries[pde_index];
}

void main(void)
{
	page_entry_t gpde = get_guest_pde(1);
	page_entry_t *ppde = get_vmm_pde(1);
}
