/* test-main-00.c (2011-11-07) */

/* DTS/SIAC Test Main */

/*#include <assert.h>*/

typedef unsigned long __kernel_size_t;
typedef __kernel_size_t size_t;
typedef unsigned int u32;
struct kmem_cache;
struct ctl_table_header;
struct ctl_table;
struct ctl_path;
struct net_protocol;
struct nf_sockopt_ops;
struct nf_hook_ops;

typedef unsigned char __u8;
typedef unsigned short __u16;
typedef __u16 __be16;
typedef signed int s32;
typedef unsigned int __u32;
typedef signed long long s64;
typedef __u32 __wsum;
typedef s32 dma_cookie_t;
typedef unsigned int sk_buff_data_t;
union ktime {
    s64 tv64;
};
typedef union ktime ktime_t;
typedef struct {
    int counter;
} atomic_t;
struct sock;
struct sec_path;
struct sk_buff {
    struct sk_buff *next;
    struct sk_buff *prev;

    struct sock *sk;
    ktime_t tstamp;
    struct net_device *dev;

    union {
	struct dst_entry *dst;
	struct rtable *rtable;
    };
    struct sec_path *sp;

    char cb[48];

    unsigned int len,
	data_len;
    __u16 mac_len,
	hdr_len;
    union {
	__wsum csum;
	struct {
	    __u16 csum_start;
	    __u16 csum_offset;
	};
    };
    __u32 priority;
    __u8 local_df:1,
	cloned:1,
	ip_summed:2,
	nohdr:1,
	nfctinfo:3;
    __u8 pkt_type:3,
	fclone:2,
	ipvs_property:1,
	peeked:1,
	nf_trace:1;
    __be16 protocol;

    void (*destructor)(struct sk_buff *skb);

    struct nf_conntrack *nfct;
    struct sk_buff *nfct_reasm;

    struct nf_bridge_info *nf_bridge;

    int iif;

    __u16 queue_mapping;

    __u16 tc_index;

    __u16 tc_verd;

    __u8 ndisc_nodetype:2;

    dma_cookie_t dma_cookie;

    __u32 secmark;

    __u32 mark;

    sk_buff_data_t transport_header;
    sk_buff_data_t network_header;
    sk_buff_data_t mac_header;

    sk_buff_data_t tail;
    sk_buff_data_t end;
    unsigned char *head,
	*data;
    unsigned int truesize;
    atomic_t users;
};

extern int ftcs_init(void);
extern void ftcs_exit(void);
extern void filter_ctor(struct kmem_cache *cache, void *ptr);
extern int icc_receive(struct sk_buff *skb);

/*@
  $ensures ($result != 0 && $unique($result));
*/
extern void *nondet_nonzero(void);

extern int nondet_value(void);

int
main(int argc, char **argv)
{
    ftcs_init();
    while (nondet_value() == 0) {
	struct sk_buff *skb = nondet_nonzero();
	skb->data = nondet_nonzero();
	icc_receive(skb);
    }
    ftcs_exit();
    return 0;
}

int
printk(const char * fmt, ...)
{
    return 0;
}

struct kmem_cache *
kmem_cache_create(const char *name,
		  size_t size,
		  size_t align,
		  unsigned long flags,
		  void (*ctor)(struct kmem_cache *, void *))
{
    struct kmem_cache *p = nondet_nonzero();
    if (ctor != 0) {
	(*ctor)(0, p);
    }
    return (struct kmem_cache *)p;
}

void
kmem_cache_destroy(struct kmem_cache *p)
{
    /*empty*/
}

/*
int
nsv4_setup(void)
{
    return 0;
}

void
nsv4_cleanup(void)
{
    /.*empty*./
}
*/

int
inet_add_protocol(struct net_protocol *prot, unsigned char num)
{
    return 0;
}

int
inet_del_protocol(struct net_protocol *prot, unsigned char num)
{
    return 0;
}

struct proc_dir_entry *
proc_mkdir(const char *p0, struct proc_dir_entry *p1)
{
    return nondet_nonzero();
}

struct ctl_table_header *
register_sysctl_paths(/*const struct ctl_path *path,
			struct ctl_table *table*/)
{
    return nondet_nonzero();
}

void
unregister_sysctl_table(struct ctl_table_header * table)
{
    /*empty*/
}

int
nf_register_sockopt(struct nf_sockopt_ops *reg)
{
    return 0;
}

void
nf_unregister_sockopt(struct nf_sockopt_ops *reg)
{
    /*empty*/
}

int
nf_register_hook(struct nf_hook_ops *reg)
{
    return 0;
}

void
nf_unregister_hook(struct nf_hook_ops *reg)
{
    /*empty*/
}

struct crypto_tfm *
crypto_alloc_base(const char *alg_name, u32 type, u32 mask)
{
    return nondet_nonzero();
}

unsigned char *
skb_pull(struct sk_buff *skb, unsigned int len)
{
    return nondet_nonzero();
}

unsigned char *
__pskb_pull_tail(struct sk_buff *skb, int delta)
{
    return nondet_nonzero();
}
